load vib1;
plot(vib1);
xlabel('time');
ylabel('vibration signals');
title('Original vibration signals  Case 1 - Run 1');


xv = vib1;

% Wavelet  de-noising parameters
level = 3;
wname = 'coif3';
tptr  = 'heursure';
sorh  = 's';
scal  = 'mln';


% Set the PCA parameters to select the number of retained principal
% components automatically by 
% Kaiser's rule. Kaiser's rule keeps the PCA components associated with
% eigenvalues greater than the mean of all eigenvalues.
npc_app = 'kais';
npc_fin = 'kais';

% Multivariate wavelet de-noising using Principal Component Analysis (PCA) on approximations in the wavelet domain and for final PCA after wavelet reconstruction.
[x_denv, npc, nestco] = wmulden(xv, level, wname, npc_app, npc_fin, tptr, sorh);
figure;
plot(x_denv);
xlabel('time');
ylabel('Wavelet PCA De-noised vibration signals');
title('Multivariate PCA wavelet de-noising  Case 1 - Run 1');


% Extracting de-noised vibration vectors
de_noised_vib_table1 = x_denv(1:9000,1);
de_noised_vib_spindle1 = x_denv(1:9000,2);




% Power spectrum estimation using periodogram is computed, then inverse FFT of
% log of periodogram returns power cepstrum.
Fs = 1000;
[Pxx3,f] = periodogram(de_noised_vib_table1,[],'twosided',[],Fs);
Pxx3 = log(Pxx3);
power_cepstrum3 = ifft(Pxx3);
figure;
plot(power_cepstrum3);
xlabel('Quefrency (ms)');
ylabel('Power cepstrum magnitude-gamnitude (dB)');
title('Power Cepstrum of de-noised vibration signal of table  Case 1 - Run 1');

Fs = 1000;
[Pxx4,f] = periodogram(de_noised_vib_spindle1,[],'twosided',[],Fs);
Pxx4 = log(Pxx4);
power_cepstrum4 = ifft(Pxx4);
figure;
plot(power_cepstrum4);
xlabel('Quefrency (ms)');
ylabel('Power cepstrum magnitude-gamnitude (dB)');
title('Power Cepstrum of de-noised vibration signal of spindle  Case 1 - Run 1');
















